//---------------------------------------------------------------------------
//
//   BevelMultiFace
//
//          Copyright(C) 2014, Tark
//
//     IʂɂăxxAʂ𕡐iɕ
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"
#include "MQWidget.h"
#include "MQSetting.h"

#include <unordered_map>

#include "CMQObject.h"
#include "BevelMultiFace.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void BevelMultiFace::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A1878;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *BevelMultiFace::GetPlugInName(void)
{
	// vOC
	return "BevelMultiFace ver.1.1 Copyright(C) 2014, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *BevelMultiFace::EnumString(int index)
{
	switch(index){
	case 0: return "BevelMultiFace"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static BevelMultiFace plugin;
	return &plugin;
}

BOOL BevelMultiFace::Execute(int index, MQDocument doc_)
{
	switch(index){
	case 0:
		{
			doc = cmq::CMQDocument(doc_);
			return main();
		}
	}
	return FALSE;
}

BevelMultiFace::BevelMultiFace() : doc(nullptr)
{
}

BevelMultiFace::~BevelMultiFace()
{
}

BOOL BevelMultiFace::main()
{
	if(!callDialog()) {
		return FALSE;
	}
	cmq::CMQObject obj = doc.getCurrentObject();
	std::set<cmq::findex_t> faces;
	std::unordered_multimap<cmq::findex_t, int> outline;
	std::unordered_map<cmq::flindex_t, PointMap> vertlist;
	std::vector<OrderFace> orderface;


	// AEgĈȂʂ͖@offsetړ
	// AEgCoffsetoAinsetֈړ
	extudeface(obj, faces, outline, vertlist, orderface);

	// WƂ̊ԂtimesŊʒuɒ_ǉ
	makesideface(obj, outline, vertlist, orderface);

	// verlistf
	// Xgɂ钸_͐VWֈړAXgɂȂ_͒ǉ
	makeVertexes(obj, vertlist);

	// orderfacef
	// ǉ UVvZ
	makeFaces(obj, vertlist, orderface);

	return TRUE;
}

MQPoint bezier(double t, const MQPoint &p0, const MQPoint &p1, const MQPoint &p2)
{
	return p0 * std::pow(1.0 - t, 2) + p1 * 2.0 * t * (1.0 - t) + p2 * std::pow(t, 2);
}

// ʂo
void BevelMultiFace::extudeface(cmq::CMQObject &obj, std::set<cmq::findex_t> &faces,
								std::unordered_multimap<cmq::findex_t, int> &outline,
								std::unordered_map<cmq::flindex_t, PointMap> &vertlist,
								std::vector<OrderFace> &orderface)
{
	std::vector<cmq::vindex_t> varraybuf(5);
	cmq::CMQContainer<cmq::CMQFace, cmq::CMQObject> fcontainer(&obj);
	for(auto fit = fcontainer.begin(); fit != fcontainer.end(); ++fit) {
		if(fit->isSelect()) {
			faces.insert(fit.index());
			// @
			MQPoint normal = obj.getNormalVector(fit.index());
			normal.normalize();
			auto varray = fit->getFacePointArray(varraybuf);
			std::vector<cmq::flindex_t> newvarray; // Iʂ̃xx̒_Xg
			newvarray.reserve(varray.size());
			for(int i = 0; i < varray.size(); i++) {
				// AEgC擾
				cmq::vindex_t v1 = varray[i];
				cmq::vindex_t v2 = varray[(i + 1) % varray.size()];
				auto otherline = obj.getOtherLine(v1, v2, fit.index(), true);
				if(otherline.empty()) {
					// AEgC
					outline.insert(std::make_pair(fit.index(), i));
				}
			}
			auto findit = outline.equal_range(fit.index());
			for(int i = 0; i < varray.size(); i++) {
				MQPoint insetvec(0, 0, 0);
				int count = 0;
				for(auto it = findit.first; it != findit.second; ++it) {
					// AEgC͕ӃxNgƖʖ@Ƃ̖@xNg擾insetvZ
					int lindex = it->second;
					MQPoint linevec;
					if(lindex == i) {
						linevec = obj.getLineVector(fit.index(), lindex);
					}
					else if((lindex + 1) % varray.size() == i) {
						linevec = obj.getLineVector(fit.index(), lindex);
					}
					else {
						continue;
					}
					MQPoint inset = cmq::CMQPoint::outercross(linevec, normal);
					inset.normalize();
					insetvec += inset;
					count++;
				}
				if(count > 1) {
					insetvec /= (float)count;
				}
				cmq::vindex_t vindex = varray[i];
				cmq::flindex_t key = cmq::makeFaceLineId(vindex, m_times); // _nԖڂ̒_L[
				MQPoint p0 = obj.getVertex(vindex);
				MQPoint p2 = p0 + normal * m_offset + insetvec * m_inset; // ړW
				// VK쐬\񒸓_Xgɒǉ
				auto find = vertlist.find(key);
				if(find != vertlist.end()) {
					PointMap &m = find->second;
					m.m_p.push_back(p2);
				}
				else {
					PointMap m(key, p2);
					vertlist.insert(std::make_pair(key, m));
				}
				newvarray.push_back(key);
				// ʂN_ƂȂ錳_vertlistɓo^Ă
				cmq::flindex_t key0 = cmq::makeFaceLineId(vindex, 0); // _L[
				auto find0 = vertlist.find(key0);
				if(find0 == vertlist.end()) {
					PointMap m(key0, p0, vindex);
					vertlist.insert(std::make_pair(key0, m));
				}
				// ʂ̒_쐬\
				MQPoint p1;
				if(m_mode == 0) {
					p1 = p0 + normal * m_offset;
				}
				else if(m_mode == 2) {
					p1 = p0 + insetvec * m_inset;
				}
				if(m_times > 1) {
					for(int i = 1; i < m_times; i++) {
						// ʕ_
						MQPoint p;
						double t = (double)i / (double)m_times;
						switch(m_mode) {
						case 1: p = p0 + (p2 - p0) * (float)t; break;
						case 0: case 2: p = bezier(t, p0, p1, p2); break;
						}
						cmq::flindex_t key = cmq::makeFaceLineId(vindex, i); // _nԖڂ̒_L[
						auto find = vertlist.find(key);
						if(find != vertlist.end()) {
							PointMap &m = find->second;
							m.m_p.push_back(p);
						}
						else {
							PointMap m(key, p);
							vertlist.insert(std::make_pair(key, m));
						}
					}
				}
			}
			// Iʂ̃xx̖ʂ̍쐬\
			OrderFace newface(newvarray, fit.index());
			orderface.push_back(newface);
		}
	}
	
}

// ʂ쐬\
void BevelMultiFace::makesideface(cmq::CMQObject &obj, std::unordered_multimap<cmq::findex_t, int> &outline,
				  std::unordered_map<cmq::flindex_t, PointMap> &vertlist,
				  std::vector<OrderFace> &orderface)
{
	for(auto &fpair : outline) {
		auto &findex = fpair.first;
		int &lindex = fpair.second;
		auto vpair = obj.getLineVertex(findex, lindex);
		cmq::vindex_t &v1 = vpair.first;
		cmq::vindex_t &v2 = vpair.second;
		for(int i = 0; i < m_times; i++) {
			std::vector<cmq::flindex_t> newvarray;
			newvarray.reserve(4);
			cmq::flindex_t key1 = cmq::makeFaceLineId(v1, i);
			cmq::flindex_t key2 = cmq::makeFaceLineId(v2, i);
			cmq::flindex_t key3 = cmq::makeFaceLineId(v2, i + 1);
			cmq::flindex_t key4 = cmq::makeFaceLineId(v1, i + 1);
			newvarray.push_back(key1);
			newvarray.push_back(key2);
			newvarray.push_back(key3);
			newvarray.push_back(key4);
			OrderFace newface(newvarray);
			newface.m_neighbor_line = cmq::makeFaceLineId(findex, lindex);
			orderface.push_back(newface);
		}

	}
}

// VK쐬\񒸓_Xgɓo^ꂽ_쐬
void BevelMultiFace::makeVertexes(cmq::CMQObject &obj, std::unordered_map<cmq::flindex_t, PointMap> &vertlist)
{
	for(auto &pair : vertlist) {
		auto &pmap = pair.second;
		if(pmap.m_vindex >= 0) {
			continue;
		}
		MQPoint p1;
		if(pmap.m_p.size() > 1) {
			// _ꍇ͂̕ψʒuɂ
			p1.zero();
			for(MQPoint &p : pmap.m_p) {
				p1 += p;
			}
			p1 /= (float)pmap.m_p.size();
		}
		else {
			p1 = pmap.m_p.front();
		}
		cmq::vindex_t vindex = obj.addVertex(p1);
		pmap.m_vindex = vindex;
	}
}

// VK쐬\ʃXgɓo^ꂽʂ쐬
void BevelMultiFace::makeFaces(cmq::CMQObject &obj, std::unordered_map<cmq::flindex_t, PointMap> &vertlist, std::vector<OrderFace> &orderface)
{
	for(auto &face : orderface) {
		auto &vlist = face.m_point;
		std::vector<cmq::vindex_t> newvarray;
		for(cmq::flindex_t key: vlist) {
			auto findit = vertlist.find(key);
			if(findit != vertlist.end()) {
				auto &pmap = findit->second;
				newvarray.push_back(pmap.m_vindex);
			}
			else {
				OutputDebugString(L"something wrong");
			}
		}
		cmq::findex_t findex = obj.addFace(newvarray);
		if(face.m_orig >= 0) {
			// xx̑IʂUVRs[
			auto carray = obj.getFaceCoordinateArray(face.m_orig);
			obj.copyFaceAttribute(findex, obj, face.m_orig, carray);
		}
		else if(face.m_neighbor_line >= 0) {
			// ʂUV̓AEgC̕ӂ̒l̂܂܃Zbg
			auto fpair = cmq::flId2FaceLinePair(face.m_neighbor_line);
			auto carray = obj.getFaceCoordinateArray(fpair.first);
			cmq::CMQCoordinate c1 = carray[fpair.second];
			cmq::CMQCoordinate c2 = carray[(fpair.second + 1) % carray.size()];
			std::vector<cmq::CMQCoordinate> newcarray(4);
			newcarray[0] = newcarray[3] = c1;
			newcarray[1] = newcarray[2] = c2;
			obj.setFaceMaterial(findex, obj.getFaceMaterial(fpair.first));
			obj.setFaceCoordinateArray(findex, newcarray);
		}
		obj.addSelectFace(findex);
	}
	// \ʂSAIʂ폜or]
	for(auto &face : orderface) {
		if(face.m_orig >= -1) {
			if(m_backface) {
				obj.invertFace(face.m_orig);
			}
			else {
				obj.deleteFace(face.m_orig);
			}
		}
	}
}

void BevelMultiFace::loadSetting()
{
	MQSetting *setting = OpenSetting();
	setting->Load("offset", m_offset, 10.0);
	setting->Load("inset", m_inset, 5.0);
	setting->Load("times", m_times, 1);
	setting->Load("mode", m_mode, 1);
	setting->Load("backface", m_backface, false);
	setting->Load("PosX", posX, -1);
	setting->Load("PosY", posY, -1);
	CloseSetting(setting);
}

void BevelMultiFace::saveSetting()
{
	MQSetting *setting = OpenSetting();
	setting->Save("offset", m_offset);
	setting->Save("inset", m_inset);
	setting->Save("times", m_times);
	setting->Save("mode", m_mode);
	setting->Save("backface", m_backface);
	setting->Save("PosX", posX);
	setting->Save("PosY", posY);
	CloseSetting(setting);
}

BOOL BevelMultiFace::callDialog()
{
	loadSetting();
	MQWindow mainwin = MQWindow::GetMainWindow();
	BevelMultiFaceDialog dlg(mainwin, this);
	dlg.m_offset->SetPosition(m_offset);
	dlg.m_inset->SetPosition(m_inset);
	dlg.m_times->SetPosition(m_times);
	dlg.m_radio[m_mode]->SetChecked(true);
	dlg.m_backface->SetChecked(m_backface);
	if(posX >= 0 && posY >= 0) {
		dlg.SetPosX(posX);
		dlg.SetPosY(posY);
	}
	if(dlg.Execute() != MQDialog::DIALOG_OK){
		return FALSE;
	}
	m_offset = (float)dlg.m_offset->GetPosition();
	m_inset = (float)dlg.m_inset->GetPosition();
	m_times = dlg.m_times->GetPosition();
	m_backface = dlg.m_backface->GetChecked();
	for(int i = 0; i < 3; i++) {
		if(dlg.m_radio[i]->GetChecked()) {
			m_mode = i;
			break;
		}
	}
	posX = dlg.GetPosX();
	posY = dlg.GetPosY();
	saveSetting();

	return TRUE;
}

//------------------------------------------------------------------------------

BevelMultiFaceDialog::BevelMultiFaceDialog(MQWindowBase& parent, BevelMultiFace *plugin)
	: MQDialog(parent), m_pPlugin(plugin)
{
	setlocale(LC_CTYPE, "");
	wchar_t buffer[256] = L"BevelMultiFace";
	SetTitle(buffer);

	MQFrame *mainFrame = CreateVerticalFrame(this);
	{
		MQFrame *frame1 = CreateHorizontalFrame(mainFrame);
		MQLabel *label1 = CreateLabel(frame1, L"(&O)ffset");
		m_offset = CreateDoubleSpinBox(frame1);
		m_offset->SetPosition(10.0);
		m_offset->SetMax(9999.0);
		m_offset->SetDecimalDigit(2);
		m_offset->SetVisibleColumn(7);
		MQLabel *label2 = CreateLabel(frame1, L"(&I)nset");
		m_inset = CreateDoubleSpinBox(frame1);
		m_inset->SetPosition(5.0);
		m_inset->SetMin(9999);
		m_inset->SetMin(-9999.0);
		m_inset->SetDecimalDigit(2);
		m_inset->SetVisibleColumn(6);
		MQLabel *label3 = CreateLabel(frame1, L"(&T)imes");
		m_times = CreateSpinBox(frame1);
		m_times->SetPosition(1);
		m_times->SetMin(1);
		m_times->SetVisibleColumn(3);
	}
	{
		MQGroupBox *group1 = CreateGroupBox(mainFrame);
		group1->SetAlignment(MQFrameBase::ALIGN_HORIZONTAL);
		group1->SetShowTitle(false);
		m_radio[0] = CreateRadioButton(group1, L"Conve(&x)");
		m_radio[1] = CreateRadioButton(group1, L"(&F)lat");
		m_radio[2] = CreateRadioButton(group1, L"Conca(&v)e");
//		m_radio[1]->SetChecked(true);
		for(int i = 0; i < 3; i++) {
			m_radio[i]->AddChangedEvent(this, &BevelMultiFaceDialog::radioevent);
			m_radio[i]->SetFillBeforeRate(1);
			m_radio[i]->SetFillAfterRate(1);
		}
	}
	{
		MQFrame *frame3 = CreateHorizontalFrame(mainFrame);
		m_backface = CreateCheckBox(frame3, L"make (&b)ack");
		MQFrame *frame4 = CreateHorizontalFrame(frame3);
		frame4->SetFillBeforeRate(0.4);
		MQButton *button_ok = CreateButton(frame4, L"OK");
		button_ok->SetDefault(true);
		button_ok->SetModalResult(DIALOG_OK);
		MQButton *button_cancel = CreateButton(frame4, L"Cancel");
		button_cancel->SetCancel(true);
		button_cancel->SetModalResult(DIALOG_CANCEL);
	}

	this->AddKeyDownEvent(this, &BevelMultiFaceDialog::keyevent);
}

BOOL BevelMultiFaceDialog::radioevent(MQWidgetBase *sender, MQDocument doc)
{
	for(int i = 0; i < 3; i++) {
		m_radio[i]->SetChecked(m_radio[i] == sender);
	}
	return FALSE;
}

BOOL BevelMultiFaceDialog::keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param)
{
	if(param.Alt) {
		switch(param.Key) {
		case 0x4F: m_offset->SetFocus(true); break;
		case 0x49: m_inset->SetFocus(true); break;
		case 0x54: m_times->SetFocus(true); break;
		case 0x58: radioevent(m_radio[0], doc); break;
		case 0x46: radioevent(m_radio[1], doc); break;
		case 0x56: radioevent(m_radio[2], doc); break;
		case 0x42: m_backface->SetChecked(!m_backface->GetChecked()); break;
		}
	}
	return FALSE;
}

